/* ***********************************************************
 * This file was automatically generated on 2021-05-06.      *
 *                                                           *
 * C# Bindings Version 2.1.30                                *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generators git repository on tinkerforge.com       *
 *************************************************************/

using System;

namespace Tinkerforge
{
	/// <summary>
	///  Communicates with CAN bus devices
	/// </summary>
	public class BrickletCAN : Device
	{
		/// <summary>
		///  Used to identify this device type in
		///  <see cref="Tinkerforge.IPConnection.EnumerateCallback"/>.
		/// </summary>
		public static int DEVICE_IDENTIFIER = 270;

		/// <summary>
		///  The display name of this device.
		/// </summary>
		public static string DEVICE_DISPLAY_NAME = "CAN Bricklet";

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_WRITE_FRAME = 1;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_READ_FRAME = 2;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_ENABLE_FRAME_READ_CALLBACK = 3;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_DISABLE_FRAME_READ_CALLBACK = 4;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_IS_FRAME_READ_CALLBACK_ENABLED = 5;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_SET_CONFIGURATION = 6;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_GET_CONFIGURATION = 7;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_SET_READ_FILTER = 8;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_GET_READ_FILTER = 9;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_GET_ERROR_LOG = 10;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_SET_FRAME_READABLE_CALLBACK_CONFIGURATION = 12;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_GET_FRAME_READABLE_CALLBACK_CONFIGURATION = 13;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_GET_IDENTITY = 255;

		private const int CALLBACK_FRAME_READ = 11;

		private const int CALLBACK_FRAME_READABLE = 14;


		/// <summary>
		/// </summary>
		public const byte FRAME_TYPE_STANDARD_DATA = 0;

		/// <summary>
		/// </summary>
		public const byte FRAME_TYPE_STANDARD_REMOTE = 1;

		/// <summary>
		/// </summary>
		public const byte FRAME_TYPE_EXTENDED_DATA = 2;

		/// <summary>
		/// </summary>
		public const byte FRAME_TYPE_EXTENDED_REMOTE = 3;

		/// <summary>
		/// </summary>
		public const byte BAUD_RATE_10KBPS = 0;

		/// <summary>
		/// </summary>
		public const byte BAUD_RATE_20KBPS = 1;

		/// <summary>
		/// </summary>
		public const byte BAUD_RATE_50KBPS = 2;

		/// <summary>
		/// </summary>
		public const byte BAUD_RATE_125KBPS = 3;

		/// <summary>
		/// </summary>
		public const byte BAUD_RATE_250KBPS = 4;

		/// <summary>
		/// </summary>
		public const byte BAUD_RATE_500KBPS = 5;

		/// <summary>
		/// </summary>
		public const byte BAUD_RATE_800KBPS = 6;

		/// <summary>
		/// </summary>
		public const byte BAUD_RATE_1000KBPS = 7;

		/// <summary>
		/// </summary>
		public const byte TRANSCEIVER_MODE_NORMAL = 0;

		/// <summary>
		/// </summary>
		public const byte TRANSCEIVER_MODE_LOOPBACK = 1;

		/// <summary>
		/// </summary>
		public const byte TRANSCEIVER_MODE_READ_ONLY = 2;

		/// <summary>
		/// </summary>
		public const byte FILTER_MODE_DISABLED = 0;

		/// <summary>
		/// </summary>
		public const byte FILTER_MODE_ACCEPT_ALL = 1;

		/// <summary>
		/// </summary>
		public const byte FILTER_MODE_MATCH_STANDARD = 2;

		/// <summary>
		/// </summary>
		public const byte FILTER_MODE_MATCH_STANDARD_AND_DATA = 3;

		/// <summary>
		/// </summary>
		public const byte FILTER_MODE_MATCH_EXTENDED = 4;


		/// <summary>
		///  This callback is triggered if a data or remote frame was received by the CAN
		///  transceiver.
		///  
		///  The ``identifier`` return value follows the identifier format described for
		///  <see cref="Tinkerforge.BrickletCAN.WriteFrame"/>.
		///  
		///  For remote frames the ``data`` return value always contains invalid values.
		///  
		///  A configurable read filter can be used to define which frames should be
		///  received by the CAN transceiver at all (see <see cref="Tinkerforge.BrickletCAN.SetReadFilter"/>).
		///  
		///  To enable this callback, use <see cref="Tinkerforge.BrickletCAN.EnableFrameReadCallback"/>.
		/// </summary>
		public event FrameReadEventHandler FrameReadCallback;
		/// <summary>
		/// </summary>
		public delegate void FrameReadEventHandler(BrickletCAN sender, byte frameType, long identifier, byte[] data, byte length);

		/// <summary>
		/// </summary>
		public event FrameReadEventHandler FrameRead // for backward compatibility
		{
			add { FrameReadCallback += value; }
			remove { FrameReadCallback -= value; }
		}

		/// <summary>
		///  This callback is triggered if a data or remote frame was received by the CAN
		///  transceiver. The received frame can be read with <see cref="Tinkerforge.BrickletCAN.ReadFrame"/>.
		///  If additional frames are received, but <see cref="Tinkerforge.BrickletCAN.ReadFrame"/> was not called yet, the callback
		///  will not trigger again.
		///  
		///  A configurable read filter can be used to define which frames should be
		///  received by the CAN transceiver and put into the read queue (see
		///  <see cref="Tinkerforge.BrickletCAN.SetReadFilter"/>).
		///  
		///  To enable this callback, use <see cref="Tinkerforge.BrickletCAN.SetFrameReadableCallbackConfiguration"/>.
		///  
		///  .. versionadded:: 2.0.1$nbsp;(Plugin)
		/// </summary>
		public event FrameReadableEventHandler FrameReadableCallback;
		/// <summary>
		/// </summary>
		public delegate void FrameReadableEventHandler(BrickletCAN sender);

		/// <summary>
		/// </summary>
		public event FrameReadableEventHandler FrameReadable // for backward compatibility
		{
			add { FrameReadableCallback += value; }
			remove { FrameReadableCallback -= value; }
		}

		/// <summary>
		///  Creates an object with the unique device ID <c>uid</c> and adds  it to
		///  the IPConnection <c>ipcon</c>.
		/// </summary>
		public BrickletCAN(string uid, IPConnection ipcon) : base(uid, ipcon, DEVICE_IDENTIFIER, DEVICE_DISPLAY_NAME)
		{
			apiVersion[0] = 2;
			apiVersion[1] = 0;
			apiVersion[2] = 1;

			callbackWrappers[CALLBACK_FRAME_READ] = new CallbackWrapper(OnFrameReadCallback);
			callbackWrappers[CALLBACK_FRAME_READABLE] = new CallbackWrapper(OnFrameReadableCallback);


			responseExpected[FUNCTION_WRITE_FRAME] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_READ_FRAME] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_ENABLE_FRAME_READ_CALLBACK] = ResponseExpectedFlag.TRUE;
			responseExpected[FUNCTION_DISABLE_FRAME_READ_CALLBACK] = ResponseExpectedFlag.TRUE;
			responseExpected[FUNCTION_IS_FRAME_READ_CALLBACK_ENABLED] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_SET_CONFIGURATION] = ResponseExpectedFlag.FALSE;
			responseExpected[FUNCTION_GET_CONFIGURATION] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_SET_READ_FILTER] = ResponseExpectedFlag.FALSE;
			responseExpected[FUNCTION_GET_READ_FILTER] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_GET_ERROR_LOG] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_SET_FRAME_READABLE_CALLBACK_CONFIGURATION] = ResponseExpectedFlag.TRUE;
			responseExpected[FUNCTION_GET_FRAME_READABLE_CALLBACK_CONFIGURATION] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_GET_IDENTITY] = ResponseExpectedFlag.ALWAYS_TRUE;

			ipcon.AddDevice(this);
		}

		/// <summary>
		///  Writes a data or remote frame to the write buffer to be transmitted over the
		///  CAN transceiver.
		///  
		///  The Bricklet supports the standard 11-bit (CAN 2.0A) and the additional extended
		///  18-bit (CAN 2.0B) identifiers. For standard frames the Bricklet uses bit 0 to 10
		///  from the ``identifier`` parameter as standard 11-bit identifier. For extended
		///  frames the Bricklet additionally uses bit 11 to 28 from the ``identifier``
		///  parameter as extended 18-bit identifier.
		///  
		///  For remote frames the ``data`` parameter is ignored.
		///  
		///  Returns *true* if the frame was successfully added to the write buffer. Returns
		///  *false* if the frame could not be added because write buffer is already full.
		///  
		///  The write buffer can overflow if frames are written to it at a higher rate
		///  than the Bricklet can transmitted them over the CAN transceiver. This may
		///  happen if the CAN transceiver is configured as read-only or is using a low baud
		///  rate (see <see cref="Tinkerforge.BrickletCAN.SetConfiguration"/>). It can also happen if the CAN bus is
		///  congested and the frame cannot be transmitted because it constantly loses
		///  arbitration or because the CAN transceiver is currently disabled due to a high
		///  write error level (see <see cref="Tinkerforge.BrickletCAN.GetErrorLog"/>).
		/// </summary>
		public bool WriteFrame(byte frameType, long identifier, byte[] data, byte length)
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(22, FUNCTION_WRITE_FRAME);
			LEConverter.To((byte)frameType, 8, request);
			LEConverter.To((int)identifier, 9, request);
			LEConverter.To((byte[])data, 13, 8, request);
			LEConverter.To((byte)length, 21, request);

			byte[] response = SendRequest(request, 9);

			return LEConverter.BoolFrom(8, response);
		}

		/// <summary>
		///  Tries to read the next data or remote frame from the read buffer and return it.
		///  If a frame was successfully read, then the ``success`` return value is set to
		///  *true* and the other return values contain the frame. If the read buffer is
		///  empty and no frame could be read, then the ``success`` return value is set to
		///  *false* and the other return values contain invalid data.
		///  
		///  The ``identifier`` return value follows the identifier format described for
		///  <see cref="Tinkerforge.BrickletCAN.WriteFrame"/>.
		///  
		///  For remote frames the ``data`` return value always contains invalid data.
		///  
		///  A configurable read filter can be used to define which frames should be
		///  received by the CAN transceiver and put into the read buffer (see
		///  <see cref="Tinkerforge.BrickletCAN.SetReadFilter"/>).
		///  
		///  Instead of polling with this function, you can also use callbacks. See the
		///  <see cref="Tinkerforge.BrickletCAN.EnableFrameReadCallback"/> function and the <see cref="Tinkerforge.BrickletCAN.FrameReadCallback"/> callback.
		/// </summary>
		public void ReadFrame(out bool success, out byte frameType, out long identifier, out byte[] data, out byte length)
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(8, FUNCTION_READ_FRAME);

			byte[] response = SendRequest(request, 23);

			success = LEConverter.BoolFrom(8, response);
			frameType = LEConverter.ByteFrom(9, response);
			identifier = LEConverter.UIntFrom(10, response);
			data = LEConverter.ByteArrayFrom(14, response, 8);
			length = LEConverter.ByteFrom(22, response);
		}

		/// <summary>
		///  Enables the <see cref="Tinkerforge.BrickletCAN.FrameReadCallback"/> callback.
		///  
		///  By default the callback is disabled. Enabling this callback will disable the <see cref="Tinkerforge.BrickletCAN.FrameReadableCallback"/> callback.
		/// </summary>
		public void EnableFrameReadCallback()
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(8, FUNCTION_ENABLE_FRAME_READ_CALLBACK);

			SendRequest(request, 0);

		}

		/// <summary>
		///  Disables the <see cref="Tinkerforge.BrickletCAN.FrameReadCallback"/> callback.
		///  
		///  By default the callback is disabled.
		/// </summary>
		public void DisableFrameReadCallback()
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(8, FUNCTION_DISABLE_FRAME_READ_CALLBACK);

			SendRequest(request, 0);

		}

		/// <summary>
		///  Returns *true* if the <see cref="Tinkerforge.BrickletCAN.FrameReadCallback"/> callback is enabled, *false* otherwise.
		/// </summary>
		public bool IsFrameReadCallbackEnabled()
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(8, FUNCTION_IS_FRAME_READ_CALLBACK_ENABLED);

			byte[] response = SendRequest(request, 9);

			return LEConverter.BoolFrom(8, response);
		}

		/// <summary>
		///  Sets the configuration for the CAN bus communication.
		///  
		///  The baud rate can be configured in steps between 10 and 1000 kbit/s.
		///  
		///  The CAN transceiver has three different modes:
		///  
		///  * Normal: Reads from and writes to the CAN bus and performs active bus
		///    error detection and acknowledgement.
		///  * Loopback: All reads and writes are performed internally. The transceiver
		///    is disconnected from the actual CAN bus.
		///  * Read-Only: Only reads from the CAN bus, but does neither active bus error
		///    detection nor acknowledgement. Only the receiving part of the transceiver
		///    is connected to the CAN bus.
		///  
		///  The write timeout has three different modes that define how a failed frame
		///  transmission should be handled:
		///  
		///  * One-Shot (= -1): Only one transmission attempt will be made. If the
		///    transmission fails then the frame is discarded.
		///  * Infinite (= 0): Infinite transmission attempts will be made. The frame will
		///    never be discarded.
		///  * Milliseconds (&gt; 0): A limited number of transmission attempts will be made.
		///    If the frame could not be transmitted successfully after the configured
		///    number of milliseconds then the frame is discarded.
		/// </summary>
		public void SetConfiguration(byte baudRate, byte transceiverMode, int writeTimeout)
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(14, FUNCTION_SET_CONFIGURATION);
			LEConverter.To((byte)baudRate, 8, request);
			LEConverter.To((byte)transceiverMode, 9, request);
			LEConverter.To((int)writeTimeout, 10, request);

			SendRequest(request, 0);

		}

		/// <summary>
		///  Returns the configuration as set by <see cref="Tinkerforge.BrickletCAN.SetConfiguration"/>.
		/// </summary>
		public void GetConfiguration(out byte baudRate, out byte transceiverMode, out int writeTimeout)
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(8, FUNCTION_GET_CONFIGURATION);

			byte[] response = SendRequest(request, 14);

			baudRate = LEConverter.ByteFrom(8, response);
			transceiverMode = LEConverter.ByteFrom(9, response);
			writeTimeout = LEConverter.IntFrom(10, response);
		}

		/// <summary>
		///  Set the read filter configuration. This can be used to define which frames
		///  should be received by the CAN transceiver and put into the read buffer.
		///  
		///  The read filter has five different modes that define if and how the mask and
		///  the two filters are applied:
		///  
		///  * Disabled: No filtering is applied at all. All frames are received even
		///    incomplete and defective frames. This mode should be used for debugging only.
		///  * Accept-All: All complete and error-free frames are received.
		///  * Match-Standard: Only standard frames with a matching identifier are received.
		///  * Match-Standard-and-Data: Only standard frames with matching identifier and
		///    data bytes are received.
		///  * Match-Extended: Only extended frames with a matching identifier are received.
		///  
		///  The mask and filters are used as bit masks. Their usage depends on the mode:
		///  
		///  * Disabled: Mask and filters are ignored.
		///  * Accept-All: Mask and filters are ignored.
		///  * Match-Standard: Bit 0 to 10 (11 bits) of mask and filters are used to match
		///    the 11-bit identifier of standard frames.
		///  * Match-Standard-and-Data: Bit 0 to 10 (11 bits) of mask and filters are used
		///    to match the 11-bit identifier of standard frames. Bit 11 to 18 (8 bits) and
		///    bit 19 to 26 (8 bits) of mask and filters are used to match the first and
		///    second data byte (if present) of standard frames.
		///  * Match-Extended: Bit 0 to 10 (11 bits) of mask and filters are used
		///    to match the standard 11-bit identifier part of extended frames. Bit 11 to 28
		///    (18 bits) of mask and filters are used to match the extended 18-bit identifier
		///    part of extended frames.
		///  
		///  The mask and filters are applied in this way: The mask is used to select the
		///  identifier and data bits that should be compared to the corresponding filter
		///  bits. All unselected bits are automatically accepted. All selected bits have
		///  to match one of the filters to be accepted. If all bits for the selected mode
		///  are accepted then the frame is accepted and is added to the read buffer.
		///  
		///  <code>
		///   "Mask Bit", "Filter Bit", "Identifier/Data Bit", "Result"
		///  
		///   0, X, X, Accept
		///   1, 0, 0, Accept
		///   1, 0, 1, Reject
		///   1, 1, 0, Reject
		///   1, 1, 1, Accept
		///  </code>
		///  
		///  For example, to receive standard frames with identifier 0x123 only the mode can
		///  be set to Match-Standard with 0x7FF as mask and 0x123 as filter 1 and filter 2.
		///  The mask of 0x7FF selects all 11 identifier bits for matching so that the
		///  identifier has to be exactly 0x123 to be accepted.
		///  
		///  To accept identifier 0x123 and identifier 0x456 at the same time, just set
		///  filter 2 to 0x456 and keep mask and filter 1 unchanged.
		/// </summary>
		public void SetReadFilter(byte mode, long mask, long filter1, long filter2)
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(21, FUNCTION_SET_READ_FILTER);
			LEConverter.To((byte)mode, 8, request);
			LEConverter.To((int)mask, 9, request);
			LEConverter.To((int)filter1, 13, request);
			LEConverter.To((int)filter2, 17, request);

			SendRequest(request, 0);

		}

		/// <summary>
		///  Returns the read filter as set by <see cref="Tinkerforge.BrickletCAN.SetReadFilter"/>.
		/// </summary>
		public void GetReadFilter(out byte mode, out long mask, out long filter1, out long filter2)
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(8, FUNCTION_GET_READ_FILTER);

			byte[] response = SendRequest(request, 21);

			mode = LEConverter.ByteFrom(8, response);
			mask = LEConverter.UIntFrom(9, response);
			filter1 = LEConverter.UIntFrom(13, response);
			filter2 = LEConverter.UIntFrom(17, response);
		}

		/// <summary>
		///  Returns information about different kinds of errors.
		///  
		///  The write and read error levels indicate the current level of checksum,
		///  acknowledgement, form, bit and stuffing errors during CAN bus write and read
		///  operations.
		///  
		///  When the write error level exceeds 255 then the CAN transceiver gets disabled
		///  and no frames can be transmitted or received anymore. The CAN transceiver will
		///  automatically be activated again after the CAN bus is idle for a while.
		///  
		///  The write and read error levels are not available in read-only transceiver mode
		///  (see <see cref="Tinkerforge.BrickletCAN.SetConfiguration"/>) and are reset to 0 as a side effect of changing
		///  the configuration or the read filter.
		///  
		///  The write timeout, read register and buffer overflow counts represents the
		///  number of these errors:
		///  
		///  * A write timeout occurs if a frame could not be transmitted before the
		///    configured write timeout expired (see <see cref="Tinkerforge.BrickletCAN.SetConfiguration"/>).
		///  * A read register overflow occurs if the read register of the CAN transceiver
		///    still contains the last received frame when the next frame arrives. In this
		///    case the newly arrived frame is lost. This happens if the CAN transceiver
		///    receives more frames than the Bricklet can handle. Using the read filter
		///    (see <see cref="Tinkerforge.BrickletCAN.SetReadFilter"/>) can help to reduce the amount of received frames.
		///    This count is not exact, but a lower bound, because the Bricklet might not
		///    able detect all overflows if they occur in rapid succession.
		///  * A read buffer overflow occurs if the read buffer of the Bricklet is already
		///    full when the next frame should be read from the read register of the CAN
		///    transceiver. In this case the frame in the read register is lost. This
		///    happens if the CAN transceiver receives more frames to be added to the read
		///    buffer than are removed from the read buffer using the <see cref="Tinkerforge.BrickletCAN.ReadFrame"/>
		///    function. Using the <see cref="Tinkerforge.BrickletCAN.FrameReadCallback"/> callback ensures that the read buffer
		///    can not overflow.
		/// </summary>
		public void GetErrorLog(out byte writeErrorLevel, out byte readErrorLevel, out bool transceiverDisabled, out long writeTimeoutCount, out long readRegisterOverflowCount, out long readBufferOverflowCount)
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(8, FUNCTION_GET_ERROR_LOG);

			byte[] response = SendRequest(request, 23);

			writeErrorLevel = LEConverter.ByteFrom(8, response);
			readErrorLevel = LEConverter.ByteFrom(9, response);
			transceiverDisabled = LEConverter.BoolFrom(10, response);
			writeTimeoutCount = LEConverter.UIntFrom(11, response);
			readRegisterOverflowCount = LEConverter.UIntFrom(15, response);
			readBufferOverflowCount = LEConverter.UIntFrom(19, response);
		}

		/// <summary>
		///  Enables/disables the <see cref="Tinkerforge.BrickletCAN.FrameReadableCallback"/> callback.
		///  
		///  By default the callback is disabled. Enabling this callback will disable the <see cref="Tinkerforge.BrickletCAN.FrameReadCallback"/> callback.
		///  
		///  .. versionadded:: 2.0.1$nbsp;(Plugin)
		/// </summary>
		public void SetFrameReadableCallbackConfiguration(bool enabled)
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(9, FUNCTION_SET_FRAME_READABLE_CALLBACK_CONFIGURATION);
			LEConverter.To((bool)enabled, 8, request);

			SendRequest(request, 0);

		}

		/// <summary>
		///  Returns *true* if the <see cref="Tinkerforge.BrickletCAN.FrameReadableCallback"/> callback is enabled, *false* otherwise.
		///  
		///  .. versionadded:: 2.0.1$nbsp;(Plugin)
		/// </summary>
		public bool GetFrameReadableCallbackConfiguration()
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(8, FUNCTION_GET_FRAME_READABLE_CALLBACK_CONFIGURATION);

			byte[] response = SendRequest(request, 9);

			return LEConverter.BoolFrom(8, response);
		}

		/// <summary>
		///  Returns the UID, the UID where the Bricklet is connected to,
		///  the position, the hardware and firmware version as well as the
		///  device identifier.
		///  
		///  The position can be 'a', 'b', 'c', 'd', 'e', 'f', 'g' or 'h' (Bricklet Port).
		///  A Bricklet connected to an :ref:`Isolator Bricklet &lt;isolator_bricklet&gt;` is always at
		///  position 'z'.
		///  
		///  The device identifier numbers can be found :ref:`here &lt;device_identifier&gt;`.
		///  |device_identifier_constant|
		/// </summary>
		public override void GetIdentity(out string uid, out string connectedUid, out char position, out byte[] hardwareVersion, out byte[] firmwareVersion, out int deviceIdentifier)
		{
			byte[] request = CreateRequestPacket(8, FUNCTION_GET_IDENTITY);

			byte[] response = SendRequest(request, 33);

			uid = LEConverter.StringFrom(8, response, 8);
			connectedUid = LEConverter.StringFrom(16, response, 8);
			position = LEConverter.CharFrom(24, response);
			hardwareVersion = LEConverter.ByteArrayFrom(25, response, 3);
			firmwareVersion = LEConverter.ByteArrayFrom(28, response, 3);
			deviceIdentifier = LEConverter.UShortFrom(31, response);
		}

		/// <summary>
		/// </summary>
		protected void OnFrameReadCallback(byte[] response)
		{
			if (response.Length != 22)
			{
				return; // silently ignoring callback with wrong length
			}

			byte frameType = LEConverter.ByteFrom(8, response);
			long identifier = LEConverter.UIntFrom(9, response);
			byte[] data = LEConverter.ByteArrayFrom(13, response, 8);
			byte length = LEConverter.ByteFrom(21, response);
			var handler = FrameReadCallback;

			if (handler != null)
			{
				handler(this, frameType, identifier, data, length);
			}
		}

		/// <summary>
		/// </summary>
		protected void OnFrameReadableCallback(byte[] response)
		{
			if (response.Length != 8)
			{
				return; // silently ignoring callback with wrong length
			}

			var handler = FrameReadableCallback;

			if (handler != null)
			{
				handler(this);
			}
		}
	}
}
